#use Gtk;
#use Gtk::Keysyms;
package UI;

#init Gtk;

{
  package UI::Entry;
  
  sub cb_expose($$$)
  {
    my ($da, $rl, $event) = @_;
    my $event_area = ${$event}{'area'};
    $da->window->draw_pixmap(
      $da->style->fg_gc('normal'), ${$rl}{gdkpixmap},
      @{$event_area}[0..1],
      @{$event_area}[0..3] );
    show_cursor($rl);
    0;
  }

  sub show_cursor($)
  {
    ${$_[0]}{da}->window->draw_line($UI::cursorcolour,
      ${$_[0]}{offsets}[${$_[0]}{cursor}]+1, 0,
      ${$_[0]}{offsets}[${$_[0]}{cursor}]+1, 25);
    return 0;
  }

  sub show($$)
  {
    ${$_[0]}{win}->show;
    ${$_[0]}{da}->show;
  }

  sub cb_expose_init($$)
  {
    my $rl = $_[1];
    $$rl{gdkpixmap} = new Gtk::Gdk::Pixmap($$rl{da}->window, 600, 40);
    $$rl{gdkpixmap}->draw_rectangle($UI::bgcolour, 1, 0, 0, $$rl{width},
      $$rl{height});
    $$rl{da}->signal_disconnect($$rl{expose_init_id});
    my $c;
    for $c (@{$rl{text}}) {
      $read_line{gdkpixmap}->draw_string($UI::entryfont, $UI::textcolour,
        ${$rl{offsets}}[$x], 20, $c);
      $x++;
      ${$rl{offsets}}[$x] = ${$rl{offsets}}[$x-1]+
        $UI::entryfont->string_width($c);
    }
    $$rl{da}->signal_connect('expose_event', \&cb_expose, $rl);
    show_cursor($rl);
    return 0;
  }

  sub enter($)
  {
    ${$_[0]}{win}->destroy;
    ${$_[0]}{gdkpixmap}->draw_rectangle($UI::bgcolour, 1, 0, 0, 600, 40);
    &{${$_[0]}{'ref'}}(join('',@{${$_[0]}{text}}), @{$_[0]{args}});
  }

  sub new($$$$;$@)
  {
    # Args:
    # 0: Class
    # 1: Prompt
    # 2: OK text
    # 3: Function
    # 4: Default(optional)
    # 5..inf: Extra args.
    my %read_line;
    shift;
    my $prompt = new Gtk::Label(shift);
    $read_line{'win'} = new Gtk::Window;
    my $vbox = new Gtk::VBox(0,0);
    $vbox->pack_start($prompt,0,0,0);
    my $hbox = new Gtk::HBox(0,0);
    $read_line{da} = new Gtk::DrawingArea;
    $hbox->pack_start($read_line{da},0,0,0);
    my $ok = new Gtk::Button(shift);
    $ok->signal_connect('clicked', sub { enter($_[1]); }, \%read_line);
    $hbox->pack_start($ok,0,0,0);
    $vbox->pack_start($hbox,0,0,0);
    $read_line{win}->add($vbox);
    $read_line{'ref'} = shift;
    my $text = shift;
    my @text;
    if (defined($text)) {
      @text = split(//,$text);
    }
    my @args = @_;
    $read_line{args} = \@args;
    $read_line{da}->set_events( [ 'exposure_mask' ] );
    $read_line{width} = 600;
    $read_line{height} = $UI::entryfont->ascent+$UI::entryfont->descent+4;
    $read_line{da}->size(600,$read_line{height});
    $voffset = $UI::entryfont->ascent;
#    $read_line{da}->realize;
    $read_line{expose_init_id} = 
      $read_line{da}->signal_connect('expose_event', \&cb_expose_init,
        \%read_line);
#    $read_line{gc} = new Gtk::Gdk::GC($read_line{gdkpixmap});
    $read_line{text} = \@text;
    $read_line{cursor} = $#text+1;
    my @offsets=(0);
    if ($#text > -1) {
      my $x = 0;
      my $off = 0;
      while ($x<=$#text) {
        $off += $UI::entryfont->string_width($text[$x]);
        push(@offsets,$off);
        $x++;
      }
    }
    $read_line{offsets} = \@offsets;
    my $c;
    my $x=0;
    UI::set_winsnooper($read_line{win},
      sub {
        # 0: Widget, 1: \%read_line, 2: event
        %event = %{$_[2]};
        if ($event{'type'} eq 'key_press') {
          if (($event{'string'} eq chr(0x0a)) ||
            ($event{'string'} eq chr(0x0d))) {
            enter($_[1]);
            # Enter
            return 0;
          } elsif ($event{'keyval'} == $Gtk::Keysyms{BackSpace}) {
            if (${$_[1]}{cursor}<=0) {
              return 0;
            }
            ${$_[1]}{cursor}--;
            my $bsd = pop(@{${$_[1]}{text}});
            pop(@{${$_[1]}{offsets}});
            ${$_[1]}{gdkpixmap}->draw_string($UI::entryfont, 
              $UI::bgcolour,
              ${$_[1]}{offsets}[${$_[1]}{cursor}], $voffset, 
              $bsd);
            ${$_[1]}{da}->window->draw_pixmap(
              ${$_[1]}{da}->style->fg_gc('normal'),
              ${$_[1]}{gdkpixmap},
              0, 0, 0, 0, 600, 40);
          } elsif ($event{'string'} eq '') {
            # Handle arrows
          } else {
            push(@{${$_[1]}{text}}, $event{'string'});
            ${$_[1]}{offsets}[${$_[1]}{cursor}+1] = 
              ${$_[1]}{offsets}[${$_[1]}{cursor}] + 
                $UI::entryfont->string_width($event{'string'});
            ${$_[1]}{gdkpixmap}->draw_string($UI::entryfont,
              $UI::textcolour, ${$_[1]}{offsets}[${$_[1]}{cursor}], $voffset, 
              $event{'string'});
            ${$_[1]}{cursor}++;
            ${$_[1]}{da}->window->draw_pixmap(
              ${$_[1]}{da}->style->fg_gc('normal'),
              ${$_[1]}{gdkpixmap},
              0, 0, 0, 0, 600, 40);
          }
          show_cursor($_[1]);
          return 0;
        }
      }, \%read_line);
      $ok->show;
      $hbox->show;
      $vbox->show;
      $prompt->show;
      return bless(\%read_line, 'UI::Entry');
#    $read_line{win}->show;
  }
}

{
  package UI::TextArea;

  $lineheight = 30;
#  $margin = 10;

  sub show_cursor($)
  {
    my $xoff = ${$_[0]}{offsets}[${$_[0]}{line}][${$_[0]}{col}]+1;
    ${$_[0]}{da}->window->draw_line($UI::cursorcolour,
     $xoff, ${$_[0]}{screenline} * $lineheight,
     $xoff, ((${$_[0]}{screenline}+1) * $lineheight)-1);
  }

  sub exposure($$$)
  {
    my ($da, $ta, $event) = @_;
    my $event_area = ${$event}{'area'};
    $da->window->draw_pixmap(
      $UI::textcolour, ${$ta}{pixmap},
      @{$event_area}[0..1],
      @{$event_area}[0..3] );
    show_cursor($ta);
    0;
  }

  sub activate($$)
  {
    ${$_[1]}{pixmap} = new Gtk::Gdk::Pixmap(${$_[1]}{da}->window, 
      ${$_[1]}{width}, ${$_[1]}{pixelheight}, -1);
    $_[0]->signal_disconnect(${$_[1]}{activate_id});
    $_[0]->signal_connect('expose_event', \&exposure, $_[1]);
    if (defined(${$_[1]}{text})) {
      draw_text($_[1]); # , ${$_[1]}{text});
    }
    return 1;  # XXX Does this keep it propagating?
  }

  sub draw_empty_pixmap($)
  {
    ${$_[0]}{pixmap}->draw_rectangle($UI::bgcolour, 1, 0, 0,
      ${$_[0]}{width}, ${$_[0]}{pixelheight});
  }

  sub char_offsets($)
  {
    my @chars = split(//, $_[0]);
    my @offsets;
    my $c;
    for $c (@chars) {
      push (@offsets, $UI::entryfont->string_width($c));
    }
  }

#  sub enable_vert_scrollbar($)
#  {
#    UI::stderr("XXX Enable vert scrollbar XXX \n");
#  }

#  sub enable_horiz_scrollbar($)
#  {
#    UI::stderr("XXX Enable horiz scrollbar.\n");
#  }

  sub draw_text($;$)
  {
    # 0: TextArea object
    # 1: (Optional) Starting line
    if (!defined($_[1])) {
      $line0 = 0;
      $line1 = ${$_[0]}{height};
    } else {
      $line0 = $_[1];
      $line1 = $_[1]+${$_[0]}{height};
    }
    if ($line1 > $#{$_[0]{text}}) {
      $line1 = $#{$_[0]{text}};
    }
    my $line;
    my $linenum = 0;
    $_[0]->draw_empty_pixmap;
      
    for $line (@{${$_[0]}{text}}[$line0..$line1]) {
      if ($linenum>${$_[0]}{height}) {
        $_[0]->enable_vert_scrollbar;
        last; # XXX This the right way to break out of the loop?
      }
      my $x=0;
      my $c;
      for $c (@$line) {
        ${$_[0]}{pixmap}->draw_string($UI::entryfont, $UI::textcolour,
          ${$_[0]}{offsets}[$linenum+$line0][$x],
          ($linenum * $lineheight)+20, $c);
        $x++;
      }
      $linenum++;
    }
  }

  sub show($)
  {
    my @area = (0, 0, $_[0]{width}, $_[0]{height} * $lineheight );
    my %ev = ( area => \@area );
    exposure($_[0]{da}, $_[0], \%ev);
  }

  sub scrollvert($$)
  {
    # Scroll $_[0] vertically to line $_[1]
    ${$_[0]}{pixmap}->draw_rectangle($UI::bgcolour, 1, 0, 0,
      ${$_[0]}{width}, ${$_[0]}{height} * $lineheight);
    draw_text($_[0], $_[1]);
    ${$_[0]}{screenline} = ${$_[0]}{line} - $_[1];
    show($_[0]);
    # XXX update vert scrollbar
  }

  sub hide_cursor($)
  {
    my $off = $_[0]{offsets}[$_[0]{line}][$_[0]{col}];
    my $hoff = $_[0]{screenline} * $lineheight;
    my @area = ($off, $hoff, 2, $hoff+$lineheight);
    $_[0]{da}->window->draw_pixmap(
      $UI::textcolour, ${$_[0]}{pixmap}, @area[0..1], @area);
  }

  sub munch_char($$)
  {
    # Delete a character from the middle of the current line
    # 0: textarea
    # 1: column of char to munch
    my $line = ${$_[0]}{line};
    my $col = $_[1];
    my $delt = ${$_[0]}{offsets}[$line][$col+1] - 
      ${$_[0]}{offsets}[$line][$col];
    splice(@{${$_[0]}{text}[$line]}, $col, 1);
    splice(@{${$_[0]}{offsets}[$line]}, $col, 1);
    while ($col<=$#{${$_[0]}{offsets}[$line]}) {
      ${$_[0]}{offsets}[$line][$col] -= $delt;
      $col++;
    }
  }

  sub redraw_line_to_eol($)
  {
    my ($line, $col, $pixmap) = 
      (${$_[0]}{line}, ${$_[0]}{col}, ${$_[0]}{pixmap});
    my $xoff = ${$_[0]}{offsets}[$line][$col];
    my $width = ${$_[0]}{width}-$xoff;
    my $yoff = ${$_[0]}{screenline} * $lineheight;
    $pixmap->draw_rectangle($UI::bgcolour, 1,
      $xoff, $yoff, $width, $lineheight);
    $pixmap->draw_string($UI::entryfont, $UI::textcolour, $xoff, $yoff+20,
      join('',@{${$_[0]}{text}[$line]}[$col..$#{${$_[0]}{text}[$line]}]));
    my @area = ($xoff, $yoff, $width, $lineheight );
    my %ev = ( area => \@area );
    ${$_[0]}{da}->window->draw_pixmap($UI::textcolour, ${$_[0]}{pixmap},
      @area[0..1], @area[0..3] );
  }

  sub merge_following_line($)
  {
    # 0: Textarea
    # Pulls the line after the current line onto the ent of the current line.
    my $line = ${$_[0]}{line};
    if ($line >= $#{${$_[0]}{offsets}}) {
      return;  # No need to do anything if the next line is blank, after
               # all...
    }
    my $x = $#{${$_[0]}{offsets}[$line]};
    my $delt = ${$_[0]}{offsets}[$line][$x++];
    push(@{${$_[0]}{offsets}[$line]},
      @{${$_[0]}{offsets}[$line+1]}[1..$#{${$_[0]}{offsets}[$line+1]}]);
    splice(@{${$_[0]}{offsets}}, $line+1, 1);
    push(@{${$_[0]}{text}[$line]}, @{splice(@{${$_[0]}{text}},$line+1,1)});
    while ($x<=$#{${_[0]}{offsets}[$line]}) {
      ${$_[0]}{offsets}[$line][$x]+=$delt;
      $x++;
    }
  }

  sub redraw_from_curline($)
  {
    my $yoff = ${$_[0]}{screenline} * $lineheight;
    my @area = (0, $yoff, 
      ${$_[0]}{width}, (${$_[0]}{height} * $lineheight) - $yoff);
    ${$_[0]}{pixmap}->draw_rectangle($UI::bgcolour, 1, @area);
    my $line0 = ${$_[0]}{line}-${$_[0]}{screenline};
    my $x = ${$_[0]}{screenline};
    my $maxx;
    if (${$_[0]}{height}+$line0<=$#{${$_[0]}{text}}) {
      $maxx = ${$_[0]}{height};
    } else {
      $maxx = $#{${$_[0]}{text}} - $line0;
    }
    while ($x<=$maxx) {
      if (!exists(${$_[0]}{text}[$line0+$x])) {
        last;
      }
      ${$_[0]}{pixmap}->draw_string($UI::entryfont, $UI::textcolour,
        0, ($x * $lineheight) + 20, join('',@{${$_[0]}{text}[$line0+$x]}));
      $x++;
    }
    ${$_[0]}{da}->window->draw_pixmap($UI::textcolour, ${$_[0]}{pixmap},
      @area[0..1], @area[0..3] );
    show_cursor($_[0]);
  }

  sub refresh_vscrollbar($)
  {
    if ($#{${$_[0]}{text}}+1 != ${$_[0]}{vadj}->upper) {
      ${$_[0]}{vadj}->upper($#{${$_[0]}{text}}+1);
      ${$_[0]}{vbar}->hide;
      ${$_[0]}{vbar}->show;
    }
  }

  sub redraw($)
  {
    draw_text($_[0], ${$_[0]}{line} - ${$_[0]}{screenline});
    show($_[0]);
  }

  sub key_enter($)
  {
    my $ta = $_[0];
    my $line = ${$ta}{line};
    hide_cursor($ta);
    my $redraw = 0;
    if (${$ta}{col}>$#{${$ta}{text}[$line]}) {
      my @null = ();
      my @off = (0);
      if ($line>=$#{${$ta}{text}}) {
        push (@{${$ta}{text}},\@null);
        push (@{${$ta}{offsets}}, \@off);
      } else {
        splice(@{${$ta}{text}}, $line+1, 0, \@null);
        splice(@{${$ta}{offsets}}, $line+1, 0, \@off);
        $redraw=1;
      }
    } else {
      my $col = ${$ta}{col};
      if ($col>0) {
        # Break Line
        my @pref = @{${$ta}{text}[$line]}[0..$col-1];
        my @suff = @{${$ta}{text}[$line]}[$col..$#{${$ta}{text}[$line]}];
        splice(@{${$ta}{text}}, $line, 1, \@pref, \@suff);
        my @pref2 = @{${$ta}{offsets}[$line]}[0..$col];
        my @suff2 = @{${$ta}{offsets}[$line]}[
          $col..$#{${$ta}{offsets}[$line]}];
        my $delt = $suff2[0];
        my $x = 0;
        while ($x<=$#suff2) {
          $suff2[$x]-=$delt;
          $x++;
        }
#        push(@suff2, $suff2[$#suff2]+$enddelt);
        splice(@{${$ta}{offsets}}, $line, 1, \@pref2, \@suff2);
      } else {
        my @blank = ();
        splice(@{${$ta}{text}}, $line, 0, \@blank);
        @blanko=(0);
        splice(@{${$ta}{offsets}}, $line, 0, \@blanko);
      }
      $redraw=1;
    }
    ${$ta}{col}=0;
    ${$ta}{line}++;
    ${$ta}{screenline}++;
    refresh_vscrollbar($ta);
    if (${$ta}{screenline}>=${$ta}{height}) {
      scrollvert($ta, (${$ta}{line}-${$ta}{height}) +1);
    } elsif ($redraw) {
      # XXX Redraw from curline-1
      redraw($ta);
    }
    show_cursor($ta);
  }

  sub key_press($$$)
  {
    # 0: Widget, 1: ta, 2: Event,
    my %event = %{$_[2]};
    my $str = $event{'string'};
    my $line = ${$_[1]}{line};
    if ($str =~/^[\x0a\x0d]$/s) {
      key_enter($_[1]);
    } elsif ($event{keyval} == $Gtk::Keysyms{'BackSpace'}) {
      if (${$_[1]}{col}==0) {
        if ($line == 0) {
          return 0;
        }
        hide_cursor($_[1]);
        $line--;
        ${$_[1]}{line}--;
        ${$_[1]}{screenline}--;
        ${$_[1]}{col} = $#{${$_[1]}{offsets}[$line]};
        # At the beginning of a line
        if ($#{${$_[1]}{text}[$line+1]} >= 0) {
          # And the line's not blank
          my $eoo = $#{${$_[1]}{offsets}[$line]};
          my $delt = ${$_[1]}{offsets}[$line][$eoo];
          push(@{${$_[1]}{text}[$line]}, @{${$_[1]}{text}[$line+1]});
          push(@{${$_[1]}{offsets}[$line]},
            @{${$_[1]}{offsets}[$line+1]}[1..$#{${$_[1]}{offsets}[$line+1]}]);
          splice(@{${$_[1]}{text}}, $line+1, 1);
          splice(@{${$_[1]}{offsets}}, $line+1, 1);
          while ($eoo < $#{${$_[1]}{offsets}[$line]}) {
            $eoo++;
            ${$_[1]}{offsets}[$line][$eoo]+= $delt;
          }
          redraw_from_curline($_[1]);
          refresh_vscrollbar($_[1]);
        } else {
          # Current line is blank
          if ($line == $#{${$_[1]}{text}}) {
            pop(@{${$_[1]}{text}});
          } else {
            splice(@{${$_[1]}{text}}, $line+1, 1);
            splice(@{${$_[1]}{offsets}}, $line+1, 1);
            redraw_from_curline($_[1]);
            refresh_vscrollbar($_[1]);
          }
        }
        if (${$_[1]}{screenline}<0) {
          ${$_[1]}{screenline} = 0;
          scrollvert($_[1], ${$_[1]}{line});
        }
        show_cursor($_[1]);
      } elsif (${$_[1]}{col} > $#{${$_[1]}{text}[$line]}) {
        # I'm at the end of a line.
        pop(@{${$_[1]}{text}[$line]});
        my $endoff = pop(@{${$_[1]}{offsets}[$line]});
        my $off = ${$_[1]}{offsets}[$line][$#{${$_[1]}{offsets}[$line]}];
        my @rect = ($off, $lineheight * ${$_[1]}{screenline},
          ($endoff - $off)+2, $lineheight);
        ${$_[1]}{pixmap}->draw_rectangle($UI::bgcolour, 1, @rect);
        ${$_[1]}{da}->window->draw_pixmap($UI::textcolour, ${$_[1]}{pixmap},
          @rect[0..1], @rect);
        ${$_[1]}{col}--;
      } else {
        munch_char($_[1], ${$_[1]}{col}-1);
        # The middle of a line.
        ${$_[1]}{col}--;
        redraw_line_to_eol($_[1]);
      }
    } elsif ($event{'keyval'} == $Gtk::Keysyms{'Delete'}) {
      if (${$_[1]}{col}<=$#{${$_[1]}{text}[$line]}) {
        munch_char($_[1], ${$_[1]}{col});
        redraw_line_to_eol($_[1]);
      } else {
        merge_following_line($_[1]);
        redraw_from_curline($_[1]);
      }
    } elsif ($str ne '') {
      my $col = ${$_[1]}{col};
      my $width = $UI::entryfont->string_width($str);
      if ($col > $#{${$_[1]}{text}[$line]}) {
        my $off = ${$_[1]}{offsets}[$line][${$_[1]}{col}];
#        ${$_[1]}{pixmap}->draw_string($UI::entryfont, $UI::textcolour,
#          $off, (${$_[1]}{screenline} * $lineheight)+20, $str);
#        push(@{${$_[1]}{offsets}[$line]}, $off+$width);
#        push(@{${$_[1]}{text}[$line]}, $str);
#        ${$_[1]}{da}->window->draw_pixmap(
#          ${$_[1]}{da}->style->fg_gc('normal'), ${$_[1]}{pixmap},
#          $off, 0, $off, 0, $width, ${$_[1]}{height} * $lineheight);
#        ${$_[1]}{col}++;
        if ($off+$width >= ${$_[1]}{width}) {
          key_enter($_[1]);
          $line = ${$_[1]}{line};
          $off = 0;
          # XXX Wrap text
        }
        ${$_[1]}{pixmap}->draw_string($UI::entryfont, $UI::textcolour,
          $off, (${$_[1]}{screenline} * $lineheight)+20, $str);
        push(@{${$_[1]}{offsets}[$line]}, $off+$width);
        push(@{${$_[1]}{text}[$line]}, $str);
        ${$_[1]}{da}->window->draw_pixmap(
        ${$_[1]}{da}->style->fg_gc('normal'), ${$_[1]}{pixmap},
          $off, 0, $off, 0, $width, ${$_[1]}{height} * $lineheight);
        ${$_[1]}{col}++;
      } else {
        # Inserting char in middle of line
        my $off = ${$_[1]}{offsets}[$line][$col];
#        ${$_[1]}{pixmap}->draw_rectangle($UI::bgcolour, 1,
#          $off, $line * $lineheight, ${$_[1]}{width} - $off, $lineheight);
        splice(@{${$_[1]}{text}[$line]}, $col, 0, $str);
        splice(@{${$_[1]}{offsets}[$line]}, $col, 0, $off);
#        ${$_[1]}{pixmap}->draw_string($UI::entryfont, $UI::textcolour,
#          $off, (${$_[1]}{screenline} * $lineheight)+20, 
#          join('', @{${$_[1]}{text}[$line]}[$col..$#{${$_[1]}{text}[$line]}]));
        $col++;
        while ($col<=$#{${$_[1]}{offsets}[$line]}) {
          ${$_[1]}{offsets}[$line][$col] += $width;
          $col++;
        }
        redraw_line_to_eol($_[1]);
        ${$_[1]}{col}++;
#        show($_[1]);
        # XXX show only changed bit
      }
    } else {
      hide_cursor($_[1]);
      my $key = $event{'keyval'};
      if ($key == $Gtk::Keysyms{'Left'}) {
        if (${$_[1]}{col}>0) {
          ${$_[1]}{col}--;
        } elsif ($line>0) {
          ${$_[1]}{line}--;
          ${$_[1]}{screenline}--;
          ${$_[1]}{col} = $#{${$_[1]}{offsets}[${$_[1]}{line}]};
          if (${$_[1]}{screenline}<0) {
            ${$_[1]}{screenline} = 0;
            scrollvert($_[1], ${$_[1]}{line});
          }
        }
      } elsif ($key == $Gtk::Keysyms{'Right'}) {
        if (${$_[1]}{col}<$#{${$_[1]}{offsets}[$line]}) {
          ${$_[1]}{col}++;
        } elsif (${$_[1]}{line}<$#{${$_[1]}{'offsets'}}) {
          ${$_[1]}{col}=0;
          ${$_[1]}{line}++;
          ${$_[1]}{screenline}++;
          if (${$_[1]}{screenline}>=${$_[1]}{height}) {
            ${$_[1]}{screenline}--;
            scrollvert($_[1],${$_[1]}{line}-${$_[1]}{screenline});
          }
        }
      } elsif (($key == $Gtk::Keysyms{'Up'}) && ($line)) {
        ${$_[1]}{line}--;
        ${$_[1]}{screenline}--;
        $line--;
        # XXX Use pixelwise approximations.  Maybe store old offset?
        if (${$_[1]}{col} > $#{${$_[1]}{offsets}[$line]}) {
          ${$_[1]}{col} = $#{${$_[1]}{offsets}[$line]};
        }
        if (${$_[1]}{screenline}<0) {
          ${$_[1]}{screenline} = 0;
          scrollvert($_[1], $line);
        }
      } elsif (($key == $Gtk::Keysyms{'Down'}) && ($line<$#{${$_[1]}{text}})) {
        ${$_[1]}{line}++;
        $line++;
        ${$_[1]}{screenline}++;
        # XXX Use pixelwise approximations.  Maybe store old offset?
        if (${$_[1]}{col} > $#{${$_[1]}{offsets}[$line]}) {
          ${$_[1]}{col} = $#{${$_[1]}{offsets}[$line]};
        }
        if (${$_[1]}{screenline} >= ${$_[1]}{height}) {
          ${$_[1]}{screenline}--;
          scrollvert($_[1], $line-${$_[1]}{screenline});
        }
      } elsif ($key == $Gtk::Keysyms{'Home'}) {
        ${$_[1]}{col} = 0;
      } elsif ($key == $Gtk::Keysyms{'End'}) {
        ${$_[1]}{col} = $#{${$_[1]}{offsets}[$line]};
      }
      # XXX PageUp
      # XXX PageDown
    }
    show_cursor($_[1]);
    return 0;
  }

  sub set_text($$)
  {
    my @text = ();
    my @off = ();
    my @lines = split(/\012/s, $_[1]);
    my $line;
    for $line (@lines) {
      my @line = split(//, $line);
      push(@text,\@line);
      my @loff = (0);
      my $c;
      for $c (@line) {
        push(@loff, $loff[$#loff]+$UI::entryfont->string_width($c));
      }
      push (@off, \@loff);
    }
    ${$_[0]}{text} = \@text;
    ${$_[0]}{offsets} = \@off;
  }

  sub pixel_to_col($$)
  {
    # $_[0]: textarea
    # $_[1]: pixel
    my $line = ${$_[0]}{line};
    my $x = $#{${$_[0]}{offsets}[$line]};
    while ($_[1]<${$_[0]}{offsets}[$line][$x]) {
      $x--;
      if ($x<0) {
        return 0;
      }
    }
    return $x;
  }

  sub mouse_press($$$)
  {
    # Args: 0: Widget
    # 1: ta
    # 2: event
    my ($widget, $ta, $event) = @_;
    hide_cursor($_[1]);
    # $$event{x}: width, $$event{y}: height
    my $destline = sprintf("%d",$$event{y} / $lineheight);
    my $desiredline = $destline+($$ta{line}-$$ta{screenline});
    if (defined($$ta{text}[$desiredline])) {
      $$ta{line} = $desiredline;
      $$ta{screenline} = $destline;
    }
    $$ta{col} = pixel_to_col($ta, $$event{x});
    show_cursor($_[1]);
    return 0;
  }

  sub destroy_textarea($)
  {
    ${$_[0]}{win}->destroy;
    undef(%{$_[0]});
  }

  sub cb_cancel($$$)
  {
    destroy_textarea($_[1]);
  }

  sub cb_ok($$$)
  {
    my ($widget, $ta) = @_;
    my $line;
    my $text = '';
    for $line (@{$$ta{text}}) {
      $text .= join('',@{$line});
      $text .= "\x0a";
    }
    &{${$ta}{okfunc}}($text,@{${$ta}{okargs}});
    destroy_textarea($ta);
  }

  sub new($%)
  {
    shift(@_);  # Pop the class name
    my %args = %{$_[0]};
    if ($^W) {
      if (!exists($args{canceltext})) {
        UI::stderr("UI::TextArea::new: canceltext not supplied.\n");
      }
    }
    undef(@_);
    # Args:
    # lines: Height of drawing area, in lines of text.
    # width: Width of drawing area, in pixels.
    # prompt: Prompt text
    # oktext: OK button text
    # canceltext: Cancel button text.
    # okfunc: Ref to subroutine called when "OK" clicked.
    # default (optional): Default text.
    my %ta;
    $ta{da} = new Gtk::DrawingArea;
    $ta{da}->size($args{width}, $args{lines}*$lineheight);
    $ta{activate_id} =
      $ta{da}->signal_connect('expose_event', \&activate, \%ta);
    $ta{da}->signal_connect('button_press_event', \&mouse_press, \%ta);
    $ta{da}->add_events(['key-press-mask', 'button-press-mask']);
    $ta{pixelheight} = $args{lines}*$lineheight;
    $ta{width} = $args{width};
    $ta{widthoffset} = 0;
    if (exists($args{default}) && defined($args{default})) {
      set_text(\%ta, $args{default});
    } else {
      my @off0 = (0);
      my @off=(\@off0);
      $ta{offsets} = \@off;
      my @text0 = ();
      my @text = \@text0;
      $ta{text} = \@text;
    }
    $ta{height} = $args{lines};
    $ta{screenline} = $ta{line} = $#{$ta{text}};
    $ta{col} = $#{$ta{text}[$ta{line}]}+1;
    $ta{win} = new Gtk::Window;
    my $vbox = new Gtk::VBox(0,0);
    my $prompt = new Gtk::Label($args{prompt});
    $vbox->pack_start($prompt,0,0,0);
#    my $table = new Gtk::Table(2,2,0);
    my $hbox = new Gtk::HBox(0,0);
#    $table->attach_defaults($ta{da}, 0, 1, 0, 1);
    $hbox->pack_start($ta{da},0,0,0);
    $ta{vadj} = new Gtk::Adjustment(0, 0, $#{$ta{text}}, 1,
      $ta{height}-1, $ta{height});
    $ta{vbar} = new Gtk::VScrollbar($ta{vadj});
    $hbox->pack_start($ta{vbar},0,0,0);
#    $table->attach_defaults($ta{vbar}, 1, 2, 0, 1);
#    $ta{hadj} = new Gtk::Adjustment(0, 0, $ta{width},
#      8, # XXX Change to em-width for fontset
#      $ta{width}/2, $ta{width});
#    $ta{hbar} = new Gtk::HScrollbar($ta{hadj});
#    $table->attach_defaults($ta{hbar}, 0, 1, 1, 2);
    $vbox->pack_start($hbox,0,0,0);
    $ta{win}->add($vbox);
    $prompt->show;
#    $ta{hbar}->show;
    $ta{vbar}->show;
    $ta{vadj}->signal_connect('value-changed', sub {
      my $baseline = ${$_[1]}{line}-${$_[1]}{screenline};
      my $newval = $_[0]->get_value();
      my $delt = $newval - $baseline;
      my $dest = $baseline + $delt;
      if ($newval != $baseline) {
        if ($dest>$#{${$_[1]}{text}}) {
          $dest = $#{${$_[1]}{text}};
        } elsif ($dest<0) {
          $dest = 0;
        }
      }
      hide_cursor($_[1]);
      ${$_[1]}{screenline} = $dest % ${$_[1]}{height};
      ${$_[1]}{line} = $dest;
      my $linlen = $#{${$_[1]}{offsets}[${$_[1]}{line}]};
      if (${$_[1]}{col}>$linlen) {
        ${$_[1]}{col}=$linlen;
      }
      if ($newval != $baseline) {
        redraw($_[1]);
      } else {
        show_cursor($_[1]);
      }
      return 0;
      }, \%ta);
    $hbox->show;
    my $bbox = new Gtk::HBox(0,0);
    my $cancel = new Gtk::Button($args{canceltext});
    $cancel->signal_connect('clicked', \&cb_cancel, \%ta);
    $bbox->pack_start($cancel,0,0,0);
    my $ok = new Gtk::Button($args{oktext});
    $ok->signal_connect('clicked', \&cb_ok, \%ta);
    $ta{okfunc} = $args{okfunc};
    $bbox->pack_end($ok,0,0,0);
    $cancel->show;
    $ok->show;
    $vbox->pack_start($bbox,0,0,0);
    $bbox->show;
    $vbox->show;
    $ta{win}->signal_connect('delete_event', sub {
      undef(%{$_[1]});
      undef($_[1]);
      return 0;
      }, \%ta);
      
    return bless(\%ta, 'UI::TextArea');
  }
}

{
  package UI::StaticText;

=head2 UI::StaticText::cb_expose(WidgetRef, StaticTextRef, EventRef)

=cut

  sub init()
  {
    $lineheight = $UI::entryfont->ascent + $UI::entryfont->descent + 2;
    $maxwidth = 600; # No StaticText > 600 pixels allowed.
    $maxlines = 360 / $lineheight;
    $initialized = 1;
  }

  sub cb_expose($$$)
  {
    my ($da, $ta, $event) = @_;
    my $event_area = ${$event}{'area'};
    $da->window->draw_pixmap(
      $UI::textcolour, ${$ta}{pixmap},
      @{$event_area}[0..1], @{$event_area}[0..3] );
    0;
  }

  sub redraw_statictext($)
  {
    my $txt = $_[0];
    my $descent = $UI::entryfont->descent;
    ${$txt}{pixmap}->draw_rectangle($UI::bgcolour, 1, 0, 0, $$txt{width},
      $$txt{height});
    my $x = ${$txt}{baseline};
    my $base = $x;
    my $maxx = $#{${$txt}{text}};
    if ($maxx-$base>$maxlines) {
      $maxx = $base+$maxlines;
    }
    while ($x<=$maxx) {
      ${$txt}{pixmap}->draw_string($UI::entryfont, $UI::textcolour,
        0, ((($x-$base)+1) * $lineheight) - $descent, ${$txt}{text}[$x]);
      $x++;
    }
  }

  sub cb_expose_1st($$$)
  {
    my $txt = $_[1];
    $$txt{da}->signal_disconnect($$txt{expose_1st_id});
    ${$txt}{pixmap} = new Gtk::Gdk::Pixmap($$txt{da}->window(), $$txt{width},
      $$txt{height});
    redraw_statictext($txt);
    $$txt{da}->signal_connect('expose_event', \&cb_expose, $txt);
    0;
  }

=head1 UI::StaticText

  UI::StaticText->new(text);

  Returns a hashref.  Hash member {table} is a Gtk::Table containing
  the relevant widgets.
  
=cut

  sub cb_vscroll($$)
  {
    # 0: Text
    # 1: Adjustment
    ${$_[1]}{baseline} = $_[0]->get_value();
    redraw_statictext($_[1]);
    ${$_[1]}{da}->window->draw_pixmap(
      $UI::textcolour, ${$_[1]}{pixmap},
      0, 0, 0, 0, ${$_[1]}{width}, ${$_[1]}{height});
    0;
  }

  sub new($$)
  {
    my %txt;

    my @body = split(/\012/s, $_[1]);
    my $line;
    my $wrapped = 0;
    my $widestline = 0;
#    my $lines = 0;
    my @text = ();
    if (!defined($initialized)) {
      init();
    }
    for $line (@body) {
      my $line = pack('U*',unpack('U*',$line)); # Unicodify
      while (length($line)>79) {
        my $pref = substr($line,0,79);
        my $width = $UI::entryfont->string_width($pref);
        $line = substr($line, 79);
        while ($width>$maxwidth) {
          $line = substr($pref, -1, 1) . $line;
          substr($pref, -1, 1) = '';
          $width = $UI::entryfont->string_width($pref);
        }
        push(@text, $pref);
        if ($width>$widestline) {
          $widestline = $width;
        }
        $wrapped = 1;
      }
      my $width = $UI::entryfont->string_width($line);
      if ($width>$widestline) {
        $widestline = $width;
      }
      push(@text, $line);
    }
    $txt{text} = \@text;
    $txt{da} = new Gtk::DrawingArea();
    $txt{hbox} = new Gtk::HBox(0,0);
    $txt{hbox}->pack_start($txt{da},0,0,0);
    $txt{baseline} = 0;
    if ($#text>$maxlines) {
      $txt{vadj} = new Gtk::Adjustment(0, 0, $#text+1,
        1, $maxlines-1, $maxlines);
      $txt{vscroll} = new Gtk::VScrollbar($txt{vadj});
      $txt{hbox}->pack_start($txt{vscroll},0,0,0);
      $txt{height} = (($maxlines + 1) * $lineheight) + 2;
      $txt{vadj}->signal_connect('value-changed', \&cb_vscroll, \%txt);
    } else {
      $txt{height} = ($lineheight*($#text+1))+2;
    }
    $txt{widestline} = $widestline;
    if ($widestline<100) {
      $widestline=100;
    } elsif ($widestline>$maxwidth) {
      $widestline=$maxwidth;
    }
    $txt{da}->size($widestline, $txt{height});
    $txt{width} = $widestline;
    $txt{wrapped} = $wrapped;
    $txt{expose_1st_id} =
      $txt{da}->signal_connect('expose_event', \&cb_expose_1st, \%txt);
    return bless(\%txt, 'UI::StaticText');
  }

  sub show($$)
  {
    my $txt = $_[0];
    if (exists($$txt{vscroll})) {
      # Only show box and scrollbar if they exist.
      $$txt{vscroll}->show;
    }
    $$txt{hbox}->show;
    $$txt{da}->show;
  }
}

sub cb_textarea_cancel($$)
{
  # Triggering widget, ta
  ${$_[1]}{win}->destroy;
}

sub set_winsnooper($$$)
{
  # 0: Window, 1: Funcref, 2: Dataref
  $winsnooper_funcs{$_[0]} = $_[1];
  $winsnooper_args{$_[0]} = $_[2];
}

=head2 UI::read_textarea($prompt, $okbuttontext, $cancelbuttontext, $default,
  $okfunction, @okargs)

  Reads a multi-line text field.  If the OK button's clicked, calls the sub
  referenced by $okfunction, with the read text as the first arg and anything
  in @okargs afterwards.  @okargs is optional.

=cut

sub read_textarea($$$$$;@)
{
  # Args: 
  # 0: Prompt, 1: OK, 2: Cancel, 3: Default
  my $ta = new UI::TextArea({
    lines => 5,
    width => 600,
    prompt => $_[0],
    oktext => $_[1],
    canceltext => $_[2],
    default => $_[3],
    okfunc => $_[4]
  });
  if ($#_>=5) {
    my @okargs = @_[5..$#_];
    ${$ta}{okargs} = \@okargs;
  }
  ${$ta}{da}->show;
  set_winsnooper(${$ta}{win}, \&UI::TextArea::key_press, $ta);
  set_winsnooper(${$ta}{da}, \&UI::TextArea::key_press, $ta);
  ${$ta}{win}->show;
}

Gtk->key_snooper_install(sub {
  # 0 is widget, 1 is event
  if (exists($winsnooper_funcs{$_[0]})) {
    &{$winsnooper_funcs{$_[0]}}($_[0], $winsnooper_args{$_[0]}, $_[1]);
    return 1;
  } else {
    if (exists($_[1])) {
      $_[0]->event($_[1]);
    } else {
      stderr("Error: \$_[1] undef.  Args were (@_)\n");
    }
  }
  return 1;
} );

