#!/usr/bin/perl -T -w

###  CONFIGURATION
#
#  Set this to wherever your Yeemp modules are installed.
#  Comment it out if Yeemp is installed systemwide.
use lib '/home/deekoo/Yeemp';

#  Set this to wherever Weemp's yeemp config dir is.
$yeempdir='/home/deekoo/deekoo.net_html/technocracy/yeemp/weemp/';
$staturl='http://deekoo.net/technocracy/yeemp/weemp/staticons/';

#  The address of the person you want to pester with site-derived messages.
$recipient='deekoo~tentacle.net';
#
###  END CONFIGURATION

use Yeemp::Client;
use Yeemp::UI::Noninteractive;
use Fcntl ':flock';
use POSIX ':fcntl_h';
use CGI;

$query=new CGI;

$action = $query->param('action');

$|=1;

sub print_html_header()
{
  print "Content-type: text/html\015\012\015\012";
  print <<EOF;
<html><head><title>Yeemp/web</title></head>
<body bgcolor="#000000" text="#00ffcc" link="#ffffff" vlink="#cccccc" alink="#cc00ff" background="tracery.jpg">
<p>
EOF
  print "<i>Initializing Yeemp...</i><br>\n";
}

{
  local $^W=0;
	package UI;
	sub stderr(@) {
		print "<p>Error: @_</p>\n";
	}
}

&Yeemp::Client::initialize_client('clientdir', $yeempdir);
&Yeemp::Client::load_contact_list();
if (!defined($action)) {
  &print_html_header();
  print "<p>No action specified.  Not doing anything.</p>\n";
} elsif ($action eq 'send') {
  &print_html_header();
  if (ident_ok()) {
    $text=$query->param('text');
    if ((!defined($text)) || ($text eq '')) {
      print "<p>Blank message; nothing sent.</p>\n";
    } elsif (&Yeemp::Client::deliver_message($recipient, "From: $Yeemp::Config::my_address\012Subfrom: $ENV{REMOTE_ADDR}\012\012$text")) {
      print "<p>Message sent.</p>\n";
    } else {
      print "<p>Message not sent.</p>\n";
    }
  }
} elsif ($action eq 'create') {
  print_html_header();
  $ident = $query->param('ident');
  $ident = lc($ident);
  if ($ident!~/^([a-z]+)$/s) {
    print "<p>Only the letters A through Z may be used in identificators.</p>\n";
  }
  open_user_list();
  load_user_list();
  if (exists($user_list{$ident})) {
    print "<p>Sorry, there's already a subaccount for $ident.</p>";
  } else {
    $pw1 = $query->param('pw1');
    $pw2 = $query->param('pw2');
    if ($pw1 ne $pw2) {
      print "<p>Passwords don't match.</p>\n";
    } else {
      add_user($ident, $pw1);
    }
  }
  close_user_list();
} elsif ($action eq 'check') {
  &print_html_header();
  if (ident_ok()) {
    &show_spooled_messages();
    if (&Yeemp::Client::open_channel()) {
      print "<p><i>Logging into server...</i></p>\n";
      if (&Yeemp::Client::login_to_server) {
        print "<p><i>Logged in.</i></p>\n";
        &handle_messages();
      } else {
        print "<p><i>Login failed</i></p>\n";
      }
    }
  }
} elsif ($action eq 'status') {
  {
    package UI;
    sub stderr() { print STDERR @_,"\n"; }
  }
  local @stat=stat("$yeempdir/status");
  if ($stat[9] < time()-220) {
    &req_current_status();
    &get_status();
    local @stat=stat("$yeempdir/status");
    if ($stat[9]<time()-50) {
      sleep(5);
      &get_status();
    }
  }
  local @stat=stat("$yeempdir/status");
  if ($stat[9] < time()-220) {
    &cache_current_status("Disconnected");
  }
  local *FILE;
  open(FILE,"<$yeempdir/status");
  local $line=<FILE>;
  $line = &urlescape($line);
  print "Location: $staturl$line.jpg\015\012URI: $staturl$line.jpg\015\012\015\012";
  exit 0;
} else {
  &print_html_header();
  print "<p>Unknown action '$action' specified.</p>\n";
}

sub ident_ok()
{
  my $ident = $query->param('ident');
  if ((!defined($ident)) || ($ident eq '')) {
    $ident = $ENV{REMOTE_ADDR};
    print "<p>Using $ident as identificator.</p>\n";
    return 1;
  }
  open_user_list();
  load_user_list();
  close_user_list();
  if (exists($user_list{$ident})) {
    if ($user_list{$ident} eq md5_base64($pw)) {
      return 1;
    } else {
      print "<p>Invalid password for $ident.</p>\n";
      undef($ident);
      return 0;
    }
  }
  print "<p>No user called $ident known.</p>\n"
  return 0;
}

sub add_user($$)
{
  seek(USER_LIST,0,&SEEK_END);
  print USER_LIST "$_[0]\n";
  print USER_LIST md5_base64($_[1])."\n";
  $user_list{$_[0]} = md5_base64($_[1]);
}

sub load_user_list()
{
  seek(USER_LIST,0,&SEEK_SET);
  while (defined($user=<USER_LIST>) && defined($password=<USER_LIST>)) {
    $user_list{$user} = $password;
  }
}

sub open_user_list()
{
  if (!open(USER_LIST,"+<$yeempdir/subusers")) {
    print "<p>Error opening user list.</p>\n";
    return;
  }
  if (!flock(USER_LIST,&LOCK_EX)) {
    print "<p>Error locking user list.</p>\n";
  }
}

sub close_user_list()
{
  close(USER_LIST);
}

sub cache_current_status()
{
  print STDERR "Setting status to $_[0]\n";
  local *FILE;
  open(FILE,">$yeempdir/status");
  print FILE $_[0];
  close(FILE);
}

print <<EOF;
</body></html>
EOF

exit;

sub req_current_status()
{
  if (&Yeemp::Client::open_channel()) {
    if (&Yeemp::Client::login_to_server()) {
    if (&Yeemp::Client::deliver_message($recipient,
      "From: $Yeemp::Config::my_address\012Subfrom: $ENV{REMOTE_ADDR}\012Get: /status\012\012"),220) {
        return;
      }
    }
  }
  &cache_current_status("Weemp Error");
}

sub urlescape()
{
  local $line=$_[0];
  $line=~s/\%/\%25/gs;
  while ($line=~/([^\%a-zA-Z0-9-])/s) {
    $char=$1;
    $hex=sprintf("%02x",ord($char));
    $line=~s/\Q$char\E/\%$hex/gs;
  }
  return $line;
}

sub show_spooled_messages()
{
  local *FILE;
  local $addr=$ENV{REMOTE_ADDR};
  if ($addr=~/^(([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+))$/s) {
    $addr=$1;
    if (open(FILE,"<$Yeemp::Client::clientdir/spool/$addr")) {
      if (flock(FILE,LOCK_EX)) {
        local $/;
        local %message;
        local $file=<FILE>;
        while ($file=~/^(([^ ](.*?)\012)+)(( (.*?)\012)+)/s) {
          $message{raw}=$4;
          $message{serverheaders}=$1;
          $file=~s/^\Q$1$4\E//s;
          &Yeemp::Client::decrypt_message(\%message);
          &show_message(\%message);
        }
        unlink("$Yeemp::Client::clientdir/spool/$addr");
      } else {
        print "<p><i>Error locking spool.</i></p>\n";
      }
      close(FILE);
    }
  } else {
    print "<p>Error: Cannot untaint IP address $addr</p>\n";
  }
}

sub get_status()
{
  local $gotstat=0;
  local $message;
  while ($message = &Yeemp::Client::get_new_message()) {
    if ($message=~/^([^ ].*?)\012( .*?)$/s) {
      local %message;
      $message{serverheaders}=$1;
      $message{raw}=$2;
      local %serverheaders=
        &Yeemp::Client::split_headers($message{serverheaders});
      &Yeemp::Client::decrypt_message(\%message);
      local %headers = %{$message{userheaders}};
      print STDERR "Debug: Decrypted to $message{body}\n",%headers;
      &Yeemp::Channel::channel_command(CHANNEL, "Delete: $serverheaders{'Message ID'}");
      if (exists($headers{File}) && ($headers{File} eq '/status')) {
        $gotstat=1;
        &cache_current_status($message{body});
      } elsif (exists($headers{Status})) {
        $gotstat=1;
        &cache_current_status($headers{Status});
      } elsif (exists($headers{Subto})) {
        if ($headers{Subto}=~/^(([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+))$/) {
          if (open(FILE,
            ">>$Yeemp::Client::clientdir/spool/$headers{Subto}")) {
            if (flock(FILE,LOCK_EX)) {
              seek(FILE,0,SEEK_END);
              print FILE "$message{serverheaders}\012$message{raw}";
            }
            close(FILE);
          }
        }
      }
    } else {
      &cache_current_status("Weemp Error");
    }
  } # End while
}

sub handle_messages()
{
  local $message;
  local $got;
  while ($message = &Yeemp::Client::get_new_message()) {
    if ($message=~/^([^ ].*?)\012( .*?)$/s) {
      local %message;
      $message{serverheaders}=$1;
      $message{raw}=$2;
      local %serverheaders=
        &Yeemp::Client::split_headers($message{serverheaders});
      &Yeemp::Client::decrypt_message(\%message);
      local %headers=%{$message{userheaders}};
      &Yeemp::Channel::channel_command(CHANNEL, "Delete: $serverheaders{'Message ID'}");
      if (exists($headers{Subto})) {
        if ($headers{Subto} eq $ENV{REMOTE_ADDR}) {
          $got=1;
          &show_message(\%message);
        } else {
          if ($headers{Subto}=~/^(([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+))$/) {
            if (open(FILE,">>$Yeemp::Client::clientdir/spool/$headers{Subto}")) {
              if (flock(FILE,LOCK_EX)) {
                seek(FILE,0,SEEK_END);
                if (!print FILE "$message{serverheaders}\012$message{raw}") {
                  print "<p><i>Error storing a message for someone else.</i></p>\n";
                }
              } else {
                print "<p><i>Error locking file.</i></p>\n";
              }
              close(FILE);
            } else {
              print "<p><i>Error storing a message for someone else.</i></p>\n";
            }
          } else {
            print "<p><i>Error untainting subto header.</i></p>\n";
          }
        }
      } else {
        print "<p>Error: No subto.</p>\n";
      }
    } else {
      print "<p><i>Odd... malformed message.</i></p>\n";
      last;
    }
  }
  if (!$got) {
    print "<p><i>No messages for you found on server.</i></p>\n";
  }
}

sub show_message(%)
{
  $message=\$_[0];
  local %serverheaders=
    &Yeemp::Client::split_headers($message{serverheaders});
  print '<img src="msgtop.gif" height=64 width=512 alt="/~~~~~~~~~~~~~~~~~~~\" align=center>';
  print "<br>Received: ",gmtime($serverheaders{received}),' GMT<br>';
  foreach $header (keys(%{$message{userheaders}})) {
    print "$header: $message{userheaders}{$header}<br>\n";
  }
  $message{body}=~s/&/&amp;/gs;
  $message{body}=~s/\</&lt;/gs;
  $message{body}=~s/\>/&gt;/gs;
  $message{body}=~s/\012/\<br\>/gs;
  print "<blockquote>$message{body}</blockquote>\n";
  print '<img src="msgbottom.gif" height=32 width=128 align=right alt=""><br>';
  print "\n";
}
